#include <stdio.h>
#include "ts/HashTable.c"
#include "ts/IteratorHashTable.c"

HashTable *ht;
IteratorHashTable *it;

void Malloc(char *src,int len,int adrs) {
  if (HashTableLookup(ht,(void *)adrs)) {
    printf("%s:",src);
    printf("malloc returned pointer %d to already allocated adrs %d\n",adrs);
  }
  HashTableInsert(ht,(void *)adrs,src);
}

void Realloc(char *src,int adrs,int newsize,int newadrs) {
  if (adrs) {
    if (!HashTableLookup(ht,(void *)adrs)) {
      printf("%s: reallocing adrs %d which was not allocated\n",src,adrs);
    } else {
      HashTableRemove(ht,(void *)adrs);
    }
  }
  HashTableInsert(ht,(void *)newadrs,src);  
}

void Free(char *src,int adrs) {
  if (!HashTableLookup(ht,(void *)adrs)) {
    printf("%s: freeing adrs %d which was not allocated\n",src,adrs);
  } else {
    HashTableRemove(ht,(void *)adrs);
  }
}

int main() {
  int adrs=0;
  char *src=0;

  ht = HashTableNewInteger();
#include "malloclog.txt"
  it = IteratorHashTableNew(ht);
  if (HashTableCount(ht) > 0) {
    do {
      adrs = (int)IteratorHashTableKey(it);
      src = IteratorHashTableValue(it);
      printf("%s:0x%X\n",src,adrs);
    } while (IteratorHashTableNext(it));
  } else {
    printf("No leaks\n");
  }
}
